int mapMe(int theValueIn, int theLastValue){
  int theValueOut;
  float theValue;
  if (theValueIn>970) theValueIn=970;
  if (theValueIn<20) theValueIn=0;
  
  // flickering hack 
  theValue=((float)theValueIn*127)/970;
  if ((theValue>theLastValue+1)||(theValue<theLastValue-1)){
    theValueOut=theValue;
  } else {
    if (theValue>theLastValue){      // bigger than pre
     theValueOut=round(theValue-0.4f);
    } else {                            // smaller than pre
     theValueOut=round(theValue+0.4f);
    }
  }
  return theValueOut;
}

void controlReading(){
  for (int i=0; i<6; i++){                                                                // reading out all six control channels
//    for (int i=0; i<6; i++){      
        ctrAnalogValues[i] = 1024-analogRead(ctrPins[i]);                                 // reading analog input        
        if (ctrAnalogValues[i]!=ctrAnalogValueAverage[i]){                                // check if there could be a change
          for (int j=0; j<ctrAnalogValueStorageSize-1; j++){                              // circular buffer 
            ctrAnalogValueStorage[i][j]=ctrAnalogValueStorage[i][j+1];                    // to get an average
          }
          ctrAnalogValueStorage[i][ctrAnalogValueStorageSize-1]=ctrAnalogValues[i];       // saving the current value, too      
        ctrAnalogValueAverage[i]=0;                                                       // old average reseting
        
        for (int j=0; j<ctrAnalogValueStorageSize-1; j++){                                // addition of all, but forgett two if it was a button
          ctrAnalogValueAverage[i]+=ctrAnalogValueStorage[i][j];                          // values
        }
        ctrAnalogValueAverage[i]=ctrAnalogValueAverage[i]/(ctrAnalogValueStorageSize);  // building the average 0 - 1023   
                
        if (mapMe(ctrAnalogValues[i],ctrValuesLast[i])>=127){
          ctrValues[i]=127;
        } else if (mapMe(ctrAnalogValues[i],ctrValuesLast[i])<=0){
          ctrValues[i]=0;
        } else {
          ctrValues[i]=mapMe(ctrAnalogValueAverage[i],ctrValuesLast[i]);                    // mapping the value to 0 - 127 
        }  
        if ((ctrValues[i]<ctrValuesLast[i])||(ctrValues[i]>ctrValuesLast[i])) {           // if new value is different enough
          
          usbMIDI.sendControlChange(ctrMidiControllers[theChannelPointer][i], ctrValues[i], channel);      // send midi controller change
          ctrValuesLast[i]=ctrValues[i];                                                  // saving value for next round
          Tlc.set(ctrOutPins[i],map(ctrValues[i],0,127,0,4095));                          // sending output signal
  
/*        if (debugMidi==true){                                                           // debugging output
          Serial.print(ctrMidiControllers[theChannelPointer][i]);Serial.print("\t");Serial.print(ctrValues[i]);Serial.println(" | \t");
        }*/
               
        }
/*      if (debugController==true){                                                        // debugging output
          Serial.print(ctrAnalogValueAverage[i]);Serial.print(" \t");
      }*/
        }
//    }
  }
 /* if (debugController==true){                                                            // debugging output  
    Serial.println();
  }*/
}
