void harmonicReading(){
  
  for (int i=0; i<2; i++){                                                                             // reading out the two harmonic channels
      // velocity
      velocityAnalogValues[i] = 1024-analogRead(velocityPins[i]);                                      // reading analog input
      noteAnalogValues[i] = 1024-analogRead(notePins[i]);                                              // reading analog input
      Serial.println(velocityAnalogValues[i]);
      //for (int k=0; k<velocityAnalogValueStorageSize-1; k++){                                        // repeat 32 times! :)  
        for (int j=0; j<velocityAnalogValueStorageSize-1; j++){                                        // circular buffer 
          velocityAnalogValueStorage[i][j]=velocityAnalogValueStorage[i][j+1];                         // to get an average
          noteAnalogValueStorage[i][j]=noteAnalogValueStorage[i][j+1];                                 // to get an average
        }
        velocityAnalogValueStorage[i][velocityAnalogValueStorageSize-1]=velocityAnalogValues[i];       // saving the current value, too
        noteAnalogValueStorage[i][noteAnalogValueStorageSize-1]=noteAnalogValues[i];                   // saving the current value, too
      //}
      velocityAnalogValueAverage[i]=0;                                                                 // old average reseting
      noteAnalogValueAverage[i]=0;                                                                     // old average reseting
      for (int j=32; j<velocityAnalogValueStorageSize-1; j++){                                          // addition of all, but forgett two if it was a button
        velocityAnalogValueAverage[i]+=velocityAnalogValueStorage[i][j];                               // values
        noteAnalogValueAverage[i]+=noteAnalogValueStorage[i][j];                                       // values
      }
      velocityAnalogValueAverage[i]=velocityAnalogValueAverage[i]/(velocityAnalogValueStorageSize/2);      // building the average 0 - 1023               
      noteAnalogValueAverage[i]=noteAnalogValueAverage[i]/(noteAnalogValueStorageSize/2);                  // building the average 0 - 1023               

      if (velocityAnalogValueStorage[i][velocityAnalogValueStorageSize-1]>970) velocityAnalogValueAverage[i]=970; 
      if (velocityAnalogValueStorage[i][velocityAnalogValueStorageSize-1]<50) velocityAnalogValueAverage[i]=0;
      
      if (noteAnalogValueStorage[i][noteAnalogValueStorageSize-1]>970) noteAnalogValueAverage[i]=970; 
      if (noteAnalogValueStorage[i][noteAnalogValueStorageSize-1]<50) noteAnalogValueAverage[i]=0;
      
      velocityValues[i]=mapMe(velocityAnalogValueAverage[i],lastVelocityValues[i]);                        // mapping the value to 0 - 127 
      noteValues[i]=mapMe(noteAnalogValueAverage[i], lastNoteValues[i]);                                   // mapping the value to 0 - 127 
      
//____
      
      
      // sending midi or not
      if ((velocityValues[i]>velocityOffTreashold)&&(noteValues[i]>=1)){                                      // if velocity is > treashold
        if (noteOn[i]==true){                                                           // if note is playing
          if (lastNoteValues[i]!=noteValues[i]){
              usbMIDI.sendNoteOff(lastNoteValues[i],0,myHarmChannel[i]);                  // midi switch note off
              usbMIDI.sendNoteOn(noteValues[i], velocityValues[i], myHarmChannel[i]);     // midi play note
/*            if (debugMidi==true){                                                       // Debug output
              Serial.print("Note Off \tNote: ");Serial.print(lastNoteValues[i]);Serial.print("\tChannel: ");Serial.print(myHarmChannel[i]);Serial.print("\t");Serial.println();
              Serial.print("Note On \tNote: ");Serial.print(noteValues[i]);Serial.print("\tVelocity: ");Serial.print(velocityValues[i]);Serial.print("\tChannel: ");Serial.print(myHarmChannel[i]);Serial.print("\t");Serial.println();
            }*/
          } else if (lastVelocityValues[i]!=velocityValues[i]){
            usbMIDI.sendPolyPressure(noteValues[i], velocityValues[i], myHarmChannel[i]);  // send aftertouch
/*            if (debugMidi==true){                                                          // Debug output
              Serial.print("Poly \tNote: ");Serial.print(noteValues[i]);Serial.print("\tVelocity: ");Serial.print(velocityValues[i]);Serial.print("\tChannel: ");Serial.print(myHarmChannel[i]);Serial.print("\t");Serial.println();
            }*/
          }
        } else {
          usbMIDI.sendNoteOn(noteValues[i], velocityValues[i], myHarmChannel[i]);       // midi play note
          noteOn[i]=true;                                                               // remember the note is on
/*          if (debugMidi==true){                                                         // Debug output
            Serial.print("Note On \tNote: ");Serial.print(lastNoteValues[i]);Serial.print("\tVelocity: ");Serial.print(velocityValues[i]);Serial.print("\tChannel: ");Serial.print(myHarmChannel[i]);Serial.print("\t");Serial.println();
          }*/
        }
      } else {                                                                          // if velocity is < treashold
        if (noteOn[i]==true){                                                           // if note is playing
          usbMIDI.sendNoteOff(lastNoteValues[i],0,myHarmChannel[i]);                    // midi switch note off
          noteOn[i]=false;                                                              // remember the note is off
 /*         if (debugMidi==true){                                                         // Debug output
            Serial.print("Note Off \tNote: ");Serial.print(lastNoteValues[i]);Serial.print("\tChannel: ");Serial.print("myHarmChannel[i]");Serial.print("\t");Serial.println();
          }*/
        }
      }
      
      // Output
      if (noteOn[i]>0) Tlc.set(noteOutPins[i],4095);
      else Tlc.set(noteOutPins[i],0);
      
      if (velocityValues[i]>20) Tlc.set(velocityOutPins[i],velocityValues[i]*16);
      else Tlc.set(velocityOutPins[i],0);
      Tlc.update();
      
      lastNoteValues[i]=noteValues[i];
      lastVelocityValues[i]=velocityValues[i];
      
      if (debugHarmInput==true){                                                         // debugging output
          Serial.print(noteValues[i]);Serial.print(" \t");Serial.print(velocityValues[i]);Serial.print(" \t");
      }      

  }
  if (debugHarmInput==true){                                                         // debugging output  
    Serial.println();
  }  
}
